<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { softwareFasterDataHelper } from '../../services/software-faster.service';
import {
  SoftwareFasterHero,
  SoftwareFasterCustomerLogos,
  SoftwareFasterFeaturedContent,
  SoftwareFasterDevSecOps,
  SoftwareFasterCaseStudies,
} from '~/components/software-faster/index.vue';
import { NextStep } from '~/components/common/index.vue';
import { getPageMetadata } from '~/common/meta';

import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';

export default Vue.extend({
  name: 'SoftwareFasterPage',
  components: {
    SoftwareFasterHero,
    SoftwareFasterCustomerLogos,
    SoftwareFasterFeaturedContent,
    SoftwareFasterDevSecOps,
    SoftwareFasterCaseStudies,
    NextStep,
  },
  async asyncData({ $content, error, i18n }: any) {
    try {
      const locale = i18n.locale === i18n.defaultLocale ? '' : i18n.locale;
      let content;

      if (locale) {
        [content] = await $content(locale, 'software-faster').fetch();
      } else {
        const data = await getClient().getEntries({
          content_type: CONTENT_TYPES.PAGE,
          locale: 'en-US',
          'fields.slug': 'software-faster',
          include: 3,
        });
        const { pageContent, seoMetadata } = data.items[0].fields;

        content = softwareFasterDataHelper(pageContent, seoMetadata);
      }
      return { content };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).content,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <section class="software-faster">
    <SoftwareFasterHero :data="content.hero" />
    <SoftwareFasterFeaturedContent :data="content.featured_content" />
    <SlpContainer>
      <SoftwareFasterCustomerLogos
        :data="content.customer_logos"
        :data-aos="'fade-up'"
        :data-aos-duration="1600"
        :data-aos-offset="200"
      />
    </SlpContainer>
    <SoftwareFasterDevSecOps :data="content.devsecops" />
    <SoftwareFasterCaseStudies
      id="case-studies"
      :data="content.by_industry_case_studies"
      :offset="1"
      data-slippers-scroll="case-studies"
    />
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.4s ease-out;
}

.fade-enter,
.fade-leave-to {
  opacity: 0;
}
.slide-enter-active,
.slide-leave-active {
  transition: opacity 0.4s ease-in;
}

.slide-enter,
.slide-leave-to {
  opacity: 0;
}
.modal {
  background: transparent;
  display: flex;
  flex-direction: column;
  margin-top: $spacing-160;

  &__backdrop {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba($color-surface-700, 0.85);
    display: flex;
    justify-content: center;
    align-items: flex-start;
    z-index: 1040;
  }
}
</style>
